//****************************************Copyright (c)***********************************//
//֧֣www.openedv.com
//Ա̣http://openedv.taobao.com
//ע΢Źƽ̨΢źţ"ԭ"ѻȡFPGA & STM32ϡ
//ȨУؾ
//Copyright(C) ԭ 2018-2028
//All rights reserved
//----------------------------------------------------------------------------------------
// File name:           myiic
// Last modified Date:  2018/10/10 16:04:03
// Last Version:        V1.0
// Descriptions:        IIC 
//----------------------------------------------------------------------------------------
// Created by:          ԭ
// Created date:        2018/10/10 16:04:03
// Version:             V1.0
// Descriptions:        The original version
//
//----------------------------------------------------------------------------------------
//****************************************************************************************//

#include "../inc/myiic.h"
#include "../inc/delay.h"
#include <unistd.h>

//ʼIIC
void IIC_Init(void)
{
    IIC_SCL(1);
    IIC_SDA(1);
}

//IICʼź
void IIC_Start(void)
{
    SDA_OUT();   //sda
    IIC_SDA(1);
    IIC_SCL(1);
    usleep(2);
    IIC_SDA(0);  //STARTź:SCLΪʱSDAɸ߱
    usleep(2);
    IIC_SCL(0);  //ǯסI2Cߣ׼ͻ
}

//IICֹͣź
void IIC_Stop(void)
{
    SDA_OUT();  //sda
    IIC_SCL(0);
    IIC_SDA(0); //STOPź:SCLΪʱSDAɵͱ
    usleep(2);
    IIC_SCL(1);
    usleep(2);
    IIC_SDA(1); //I2C߽ź
    usleep(2);
}

//ȴӦźŵ
//ֵ1Ӧʧ
//        0Ӧɹ
u8 IIC_Wait_Ack(void)
{
    u8 ucErrTime=0;
    SDA_IN();      //SDAΪ
    IIC_SDA(1);
    usleep(2);
    IIC_SCL(1);
    usleep(2);
    while(READ_SDA) {
        ucErrTime++;
        if(ucErrTime>250) {
            IIC_Stop();
            return 1;
        }
    }
    IIC_SCL(0);//ʱ0
    return 0;
}

//ACKӦ
void IIC_Ack(void)
{
    IIC_SCL(0);
    SDA_OUT();
    IIC_SDA(0);
    usleep(2);
    IIC_SCL(1);
    usleep(2);
    IIC_SCL(0);
}

//ACKӦ
void IIC_NAck(void)
{
    IIC_SCL(0);
    SDA_OUT();
    IIC_SDA(1);
    usleep(1);
    IIC_SCL(1);
    usleep(1);
    IIC_SCL(0);
}

//IICһֽ
//شӻӦ
//1Ӧ
//0Ӧ
void IIC_Send_Byte(u8 txd)
{
    u8 t;
    SDA_OUT();
    IIC_SCL(0);//ʱӿʼݴ
    for(t=0; t<8; t++) {
        IIC_SDA((txd&0x80)>>7);
        txd<<=1;
        usleep(1);
        IIC_SCL(1);
        usleep(1);
        IIC_SCL(0);
        usleep(1);
    }
}

//1ֽڣack=1ʱACKack=0nACK
u8 IIC_Read_Byte(unsigned char ack)
{
    unsigned char i,receive=0;
    SDA_IN();//SDAΪ
    for(i=0; i<8; i++ ) {
        IIC_SCL(0);
        usleep(1);
        IIC_SCL(1);
        receive<<=1;
        if(READ_SDA)
            receive++;
        usleep(1);
    }
    if (!ack)
        IIC_NAck();//nACK
    else
        IIC_Ack(); //ACK
    return receive;
}
