// vl53l1x.v

// Generated using ACDS version 13.1 162 at 2020.08.24.23:10:54

`timescale 1 ps / 1 ps
module vl53l1x (
		input  wire       clk_clk,         //      clk.clk
		input  wire       reset_reset_n,   //    reset.reset_n
		output wire       i2c_sclk_export, // i2c_sclk.export
		inout  wire       i2c_sda_export,  //  i2c_sda.export
		output wire       epcs_dclk,       //     epcs.dclk
		output wire       epcs_sce,        //         .sce
		output wire       epcs_sdo,        //         .sdo
		input  wire       epcs_data0,      //         .data0
		output wire [3:0] ge_export,       //       ge.export
		output wire [3:0] shi_export,      //      shi.export
		output wire [3:0] bai_export,      //      bai.export
		output wire [3:0] qian_export      //     qian.export
	);

	wire  [31:0] mm_interconnect_0_pio_sda_s1_writedata;                       // mm_interconnect_0:pio_sda_s1_writedata -> pio_sda:writedata
	wire   [1:0] mm_interconnect_0_pio_sda_s1_address;                         // mm_interconnect_0:pio_sda_s1_address -> pio_sda:address
	wire         mm_interconnect_0_pio_sda_s1_chipselect;                      // mm_interconnect_0:pio_sda_s1_chipselect -> pio_sda:chipselect
	wire         mm_interconnect_0_pio_sda_s1_write;                           // mm_interconnect_0:pio_sda_s1_write -> pio_sda:write_n
	wire  [31:0] mm_interconnect_0_pio_sda_s1_readdata;                        // pio_sda:readdata -> mm_interconnect_0:pio_sda_s1_readdata
	wire         nios2_qsys_0_data_master_waitrequest;                         // mm_interconnect_0:nios2_qsys_0_data_master_waitrequest -> nios2_qsys_0:d_waitrequest
	wire  [31:0] nios2_qsys_0_data_master_writedata;                           // nios2_qsys_0:d_writedata -> mm_interconnect_0:nios2_qsys_0_data_master_writedata
	wire  [15:0] nios2_qsys_0_data_master_address;                             // nios2_qsys_0:d_address -> mm_interconnect_0:nios2_qsys_0_data_master_address
	wire         nios2_qsys_0_data_master_write;                               // nios2_qsys_0:d_write -> mm_interconnect_0:nios2_qsys_0_data_master_write
	wire         nios2_qsys_0_data_master_read;                                // nios2_qsys_0:d_read -> mm_interconnect_0:nios2_qsys_0_data_master_read
	wire  [31:0] nios2_qsys_0_data_master_readdata;                            // mm_interconnect_0:nios2_qsys_0_data_master_readdata -> nios2_qsys_0:d_readdata
	wire         nios2_qsys_0_data_master_debugaccess;                         // nios2_qsys_0:jtag_debug_module_debugaccess_to_roms -> mm_interconnect_0:nios2_qsys_0_data_master_debugaccess
	wire   [3:0] nios2_qsys_0_data_master_byteenable;                          // nios2_qsys_0:d_byteenable -> mm_interconnect_0:nios2_qsys_0_data_master_byteenable
	wire         mm_interconnect_0_jtag_uart_avalon_jtag_slave_waitrequest;    // jtag_uart:av_waitrequest -> mm_interconnect_0:jtag_uart_avalon_jtag_slave_waitrequest
	wire  [31:0] mm_interconnect_0_jtag_uart_avalon_jtag_slave_writedata;      // mm_interconnect_0:jtag_uart_avalon_jtag_slave_writedata -> jtag_uart:av_writedata
	wire   [0:0] mm_interconnect_0_jtag_uart_avalon_jtag_slave_address;        // mm_interconnect_0:jtag_uart_avalon_jtag_slave_address -> jtag_uart:av_address
	wire         mm_interconnect_0_jtag_uart_avalon_jtag_slave_chipselect;     // mm_interconnect_0:jtag_uart_avalon_jtag_slave_chipselect -> jtag_uart:av_chipselect
	wire         mm_interconnect_0_jtag_uart_avalon_jtag_slave_write;          // mm_interconnect_0:jtag_uart_avalon_jtag_slave_write -> jtag_uart:av_write_n
	wire         mm_interconnect_0_jtag_uart_avalon_jtag_slave_read;           // mm_interconnect_0:jtag_uart_avalon_jtag_slave_read -> jtag_uart:av_read_n
	wire  [31:0] mm_interconnect_0_jtag_uart_avalon_jtag_slave_readdata;       // jtag_uart:av_readdata -> mm_interconnect_0:jtag_uart_avalon_jtag_slave_readdata
	wire  [31:0] mm_interconnect_0_pio_bai_s1_writedata;                       // mm_interconnect_0:pio_bai_s1_writedata -> pio_bai:writedata
	wire   [1:0] mm_interconnect_0_pio_bai_s1_address;                         // mm_interconnect_0:pio_bai_s1_address -> pio_bai:address
	wire         mm_interconnect_0_pio_bai_s1_chipselect;                      // mm_interconnect_0:pio_bai_s1_chipselect -> pio_bai:chipselect
	wire         mm_interconnect_0_pio_bai_s1_write;                           // mm_interconnect_0:pio_bai_s1_write -> pio_bai:write_n
	wire  [31:0] mm_interconnect_0_pio_bai_s1_readdata;                        // pio_bai:readdata -> mm_interconnect_0:pio_bai_s1_readdata
	wire  [31:0] mm_interconnect_0_pio_ge_s1_writedata;                        // mm_interconnect_0:pio_ge_s1_writedata -> pio_ge:writedata
	wire   [1:0] mm_interconnect_0_pio_ge_s1_address;                          // mm_interconnect_0:pio_ge_s1_address -> pio_ge:address
	wire         mm_interconnect_0_pio_ge_s1_chipselect;                       // mm_interconnect_0:pio_ge_s1_chipselect -> pio_ge:chipselect
	wire         mm_interconnect_0_pio_ge_s1_write;                            // mm_interconnect_0:pio_ge_s1_write -> pio_ge:write_n
	wire  [31:0] mm_interconnect_0_pio_ge_s1_readdata;                         // pio_ge:readdata -> mm_interconnect_0:pio_ge_s1_readdata
	wire         mm_interconnect_0_nios2_qsys_0_jtag_debug_module_waitrequest; // nios2_qsys_0:jtag_debug_module_waitrequest -> mm_interconnect_0:nios2_qsys_0_jtag_debug_module_waitrequest
	wire  [31:0] mm_interconnect_0_nios2_qsys_0_jtag_debug_module_writedata;   // mm_interconnect_0:nios2_qsys_0_jtag_debug_module_writedata -> nios2_qsys_0:jtag_debug_module_writedata
	wire   [8:0] mm_interconnect_0_nios2_qsys_0_jtag_debug_module_address;     // mm_interconnect_0:nios2_qsys_0_jtag_debug_module_address -> nios2_qsys_0:jtag_debug_module_address
	wire         mm_interconnect_0_nios2_qsys_0_jtag_debug_module_write;       // mm_interconnect_0:nios2_qsys_0_jtag_debug_module_write -> nios2_qsys_0:jtag_debug_module_write
	wire         mm_interconnect_0_nios2_qsys_0_jtag_debug_module_read;        // mm_interconnect_0:nios2_qsys_0_jtag_debug_module_read -> nios2_qsys_0:jtag_debug_module_read
	wire  [31:0] mm_interconnect_0_nios2_qsys_0_jtag_debug_module_readdata;    // nios2_qsys_0:jtag_debug_module_readdata -> mm_interconnect_0:nios2_qsys_0_jtag_debug_module_readdata
	wire         mm_interconnect_0_nios2_qsys_0_jtag_debug_module_debugaccess; // mm_interconnect_0:nios2_qsys_0_jtag_debug_module_debugaccess -> nios2_qsys_0:jtag_debug_module_debugaccess
	wire   [3:0] mm_interconnect_0_nios2_qsys_0_jtag_debug_module_byteenable;  // mm_interconnect_0:nios2_qsys_0_jtag_debug_module_byteenable -> nios2_qsys_0:jtag_debug_module_byteenable
	wire   [0:0] mm_interconnect_0_sysid_control_slave_address;                // mm_interconnect_0:sysid_control_slave_address -> sysid:address
	wire  [31:0] mm_interconnect_0_sysid_control_slave_readdata;               // sysid:readdata -> mm_interconnect_0:sysid_control_slave_readdata
	wire  [31:0] mm_interconnect_0_pio_qian_s1_writedata;                      // mm_interconnect_0:pio_qian_s1_writedata -> pio_qian:writedata
	wire   [1:0] mm_interconnect_0_pio_qian_s1_address;                        // mm_interconnect_0:pio_qian_s1_address -> pio_qian:address
	wire         mm_interconnect_0_pio_qian_s1_chipselect;                     // mm_interconnect_0:pio_qian_s1_chipselect -> pio_qian:chipselect
	wire         mm_interconnect_0_pio_qian_s1_write;                          // mm_interconnect_0:pio_qian_s1_write -> pio_qian:write_n
	wire  [31:0] mm_interconnect_0_pio_qian_s1_readdata;                       // pio_qian:readdata -> mm_interconnect_0:pio_qian_s1_readdata
	wire         nios2_qsys_0_instruction_master_waitrequest;                  // mm_interconnect_0:nios2_qsys_0_instruction_master_waitrequest -> nios2_qsys_0:i_waitrequest
	wire  [15:0] nios2_qsys_0_instruction_master_address;                      // nios2_qsys_0:i_address -> mm_interconnect_0:nios2_qsys_0_instruction_master_address
	wire         nios2_qsys_0_instruction_master_read;                         // nios2_qsys_0:i_read -> mm_interconnect_0:nios2_qsys_0_instruction_master_read
	wire  [31:0] nios2_qsys_0_instruction_master_readdata;                     // mm_interconnect_0:nios2_qsys_0_instruction_master_readdata -> nios2_qsys_0:i_readdata
	wire         nios2_qsys_0_instruction_master_readdatavalid;                // mm_interconnect_0:nios2_qsys_0_instruction_master_readdatavalid -> nios2_qsys_0:i_readdatavalid
	wire  [31:0] mm_interconnect_0_epcs_epcs_control_port_writedata;           // mm_interconnect_0:epcs_epcs_control_port_writedata -> epcs:writedata
	wire   [8:0] mm_interconnect_0_epcs_epcs_control_port_address;             // mm_interconnect_0:epcs_epcs_control_port_address -> epcs:address
	wire         mm_interconnect_0_epcs_epcs_control_port_chipselect;          // mm_interconnect_0:epcs_epcs_control_port_chipselect -> epcs:chipselect
	wire         mm_interconnect_0_epcs_epcs_control_port_write;               // mm_interconnect_0:epcs_epcs_control_port_write -> epcs:write_n
	wire         mm_interconnect_0_epcs_epcs_control_port_read;                // mm_interconnect_0:epcs_epcs_control_port_read -> epcs:read_n
	wire  [31:0] mm_interconnect_0_epcs_epcs_control_port_readdata;            // epcs:readdata -> mm_interconnect_0:epcs_epcs_control_port_readdata
	wire  [31:0] mm_interconnect_0_pio_sclk_s1_writedata;                      // mm_interconnect_0:pio_sclk_s1_writedata -> pio_sclk:writedata
	wire   [1:0] mm_interconnect_0_pio_sclk_s1_address;                        // mm_interconnect_0:pio_sclk_s1_address -> pio_sclk:address
	wire         mm_interconnect_0_pio_sclk_s1_chipselect;                     // mm_interconnect_0:pio_sclk_s1_chipselect -> pio_sclk:chipselect
	wire         mm_interconnect_0_pio_sclk_s1_write;                          // mm_interconnect_0:pio_sclk_s1_write -> pio_sclk:write_n
	wire  [31:0] mm_interconnect_0_pio_sclk_s1_readdata;                       // pio_sclk:readdata -> mm_interconnect_0:pio_sclk_s1_readdata
	wire  [31:0] mm_interconnect_0_pio_shi_s1_writedata;                       // mm_interconnect_0:pio_shi_s1_writedata -> pio_shi:writedata
	wire   [1:0] mm_interconnect_0_pio_shi_s1_address;                         // mm_interconnect_0:pio_shi_s1_address -> pio_shi:address
	wire         mm_interconnect_0_pio_shi_s1_chipselect;                      // mm_interconnect_0:pio_shi_s1_chipselect -> pio_shi:chipselect
	wire         mm_interconnect_0_pio_shi_s1_write;                           // mm_interconnect_0:pio_shi_s1_write -> pio_shi:write_n
	wire  [31:0] mm_interconnect_0_pio_shi_s1_readdata;                        // pio_shi:readdata -> mm_interconnect_0:pio_shi_s1_readdata
	wire  [31:0] mm_interconnect_0_ram_s1_writedata;                           // mm_interconnect_0:ram_s1_writedata -> ram:writedata
	wire  [11:0] mm_interconnect_0_ram_s1_address;                             // mm_interconnect_0:ram_s1_address -> ram:address
	wire         mm_interconnect_0_ram_s1_chipselect;                          // mm_interconnect_0:ram_s1_chipselect -> ram:chipselect
	wire         mm_interconnect_0_ram_s1_clken;                               // mm_interconnect_0:ram_s1_clken -> ram:clken
	wire         mm_interconnect_0_ram_s1_write;                               // mm_interconnect_0:ram_s1_write -> ram:write
	wire  [31:0] mm_interconnect_0_ram_s1_readdata;                            // ram:readdata -> mm_interconnect_0:ram_s1_readdata
	wire   [3:0] mm_interconnect_0_ram_s1_byteenable;                          // mm_interconnect_0:ram_s1_byteenable -> ram:byteenable
	wire         irq_mapper_receiver0_irq;                                     // jtag_uart:av_irq -> irq_mapper:receiver0_irq
	wire         irq_mapper_receiver1_irq;                                     // epcs:irq -> irq_mapper:receiver1_irq
	wire  [31:0] nios2_qsys_0_d_irq_irq;                                       // irq_mapper:sender_irq -> nios2_qsys_0:d_irq
	wire         rst_controller_reset_out_reset;                               // rst_controller:reset_out -> [epcs:reset_n, irq_mapper:reset, mm_interconnect_0:nios2_qsys_0_reset_n_reset_bridge_in_reset_reset, nios2_qsys_0:reset_n, pio_bai:reset_n, pio_ge:reset_n, pio_qian:reset_n, pio_sclk:reset_n, pio_sda:reset_n, pio_shi:reset_n, ram:reset, rst_translator:in_reset, sysid:reset_n]
	wire         rst_controller_reset_out_reset_req;                           // rst_controller:reset_req -> [epcs:reset_req, nios2_qsys_0:reset_req, ram:reset_req, rst_translator:reset_req_in]
	wire         rst_controller_001_reset_out_reset;                           // rst_controller_001:reset_out -> [jtag_uart:rst_n, mm_interconnect_0:jtag_uart_reset_reset_bridge_in_reset_reset]
	wire         nios2_qsys_0_jtag_debug_module_reset_reset;                   // nios2_qsys_0:jtag_debug_module_resetrequest -> rst_controller_001:reset_in1

	vl53l1x_nios2_qsys_0 nios2_qsys_0 (
		.clk                                   (clk_clk),                                                      //                       clk.clk
		.reset_n                               (~rst_controller_reset_out_reset),                              //                   reset_n.reset_n
		.reset_req                             (rst_controller_reset_out_reset_req),                           //                          .reset_req
		.d_address                             (nios2_qsys_0_data_master_address),                             //               data_master.address
		.d_byteenable                          (nios2_qsys_0_data_master_byteenable),                          //                          .byteenable
		.d_read                                (nios2_qsys_0_data_master_read),                                //                          .read
		.d_readdata                            (nios2_qsys_0_data_master_readdata),                            //                          .readdata
		.d_waitrequest                         (nios2_qsys_0_data_master_waitrequest),                         //                          .waitrequest
		.d_write                               (nios2_qsys_0_data_master_write),                               //                          .write
		.d_writedata                           (nios2_qsys_0_data_master_writedata),                           //                          .writedata
		.jtag_debug_module_debugaccess_to_roms (nios2_qsys_0_data_master_debugaccess),                         //                          .debugaccess
		.i_address                             (nios2_qsys_0_instruction_master_address),                      //        instruction_master.address
		.i_read                                (nios2_qsys_0_instruction_master_read),                         //                          .read
		.i_readdata                            (nios2_qsys_0_instruction_master_readdata),                     //                          .readdata
		.i_waitrequest                         (nios2_qsys_0_instruction_master_waitrequest),                  //                          .waitrequest
		.i_readdatavalid                       (nios2_qsys_0_instruction_master_readdatavalid),                //                          .readdatavalid
		.d_irq                                 (nios2_qsys_0_d_irq_irq),                                       //                     d_irq.irq
		.jtag_debug_module_resetrequest        (nios2_qsys_0_jtag_debug_module_reset_reset),                   //   jtag_debug_module_reset.reset
		.jtag_debug_module_address             (mm_interconnect_0_nios2_qsys_0_jtag_debug_module_address),     //         jtag_debug_module.address
		.jtag_debug_module_byteenable          (mm_interconnect_0_nios2_qsys_0_jtag_debug_module_byteenable),  //                          .byteenable
		.jtag_debug_module_debugaccess         (mm_interconnect_0_nios2_qsys_0_jtag_debug_module_debugaccess), //                          .debugaccess
		.jtag_debug_module_read                (mm_interconnect_0_nios2_qsys_0_jtag_debug_module_read),        //                          .read
		.jtag_debug_module_readdata            (mm_interconnect_0_nios2_qsys_0_jtag_debug_module_readdata),    //                          .readdata
		.jtag_debug_module_waitrequest         (mm_interconnect_0_nios2_qsys_0_jtag_debug_module_waitrequest), //                          .waitrequest
		.jtag_debug_module_write               (mm_interconnect_0_nios2_qsys_0_jtag_debug_module_write),       //                          .write
		.jtag_debug_module_writedata           (mm_interconnect_0_nios2_qsys_0_jtag_debug_module_writedata),   //                          .writedata
		.no_ci_readra                          ()                                                              // custom_instruction_master.readra
	);

	vl53l1x_sysid sysid (
		.clock    (clk_clk),                                        //           clk.clk
		.reset_n  (~rst_controller_reset_out_reset),                //         reset.reset_n
		.readdata (mm_interconnect_0_sysid_control_slave_readdata), // control_slave.readdata
		.address  (mm_interconnect_0_sysid_control_slave_address)   //              .address
	);

	vl53l1x_jtag_uart jtag_uart (
		.clk            (clk_clk),                                                   //               clk.clk
		.rst_n          (~rst_controller_001_reset_out_reset),                       //             reset.reset_n
		.av_chipselect  (mm_interconnect_0_jtag_uart_avalon_jtag_slave_chipselect),  // avalon_jtag_slave.chipselect
		.av_address     (mm_interconnect_0_jtag_uart_avalon_jtag_slave_address),     //                  .address
		.av_read_n      (~mm_interconnect_0_jtag_uart_avalon_jtag_slave_read),       //                  .read_n
		.av_readdata    (mm_interconnect_0_jtag_uart_avalon_jtag_slave_readdata),    //                  .readdata
		.av_write_n     (~mm_interconnect_0_jtag_uart_avalon_jtag_slave_write),      //                  .write_n
		.av_writedata   (mm_interconnect_0_jtag_uart_avalon_jtag_slave_writedata),   //                  .writedata
		.av_waitrequest (mm_interconnect_0_jtag_uart_avalon_jtag_slave_waitrequest), //                  .waitrequest
		.av_irq         (irq_mapper_receiver0_irq)                                   //               irq.irq
	);

	vl53l1x_ram ram (
		.clk        (clk_clk),                             //   clk1.clk
		.address    (mm_interconnect_0_ram_s1_address),    //     s1.address
		.clken      (mm_interconnect_0_ram_s1_clken),      //       .clken
		.chipselect (mm_interconnect_0_ram_s1_chipselect), //       .chipselect
		.write      (mm_interconnect_0_ram_s1_write),      //       .write
		.readdata   (mm_interconnect_0_ram_s1_readdata),   //       .readdata
		.writedata  (mm_interconnect_0_ram_s1_writedata),  //       .writedata
		.byteenable (mm_interconnect_0_ram_s1_byteenable), //       .byteenable
		.reset      (rst_controller_reset_out_reset),      // reset1.reset
		.reset_req  (rst_controller_reset_out_reset_req)   //       .reset_req
	);

	vl53l1x_epcs epcs (
		.clk           (clk_clk),                                             //               clk.clk
		.reset_n       (~rst_controller_reset_out_reset),                     //             reset.reset_n
		.reset_req     (rst_controller_reset_out_reset_req),                  //                  .reset_req
		.address       (mm_interconnect_0_epcs_epcs_control_port_address),    // epcs_control_port.address
		.chipselect    (mm_interconnect_0_epcs_epcs_control_port_chipselect), //                  .chipselect
		.dataavailable (),                                                    //                  .dataavailable
		.endofpacket   (),                                                    //                  .endofpacket
		.read_n        (~mm_interconnect_0_epcs_epcs_control_port_read),      //                  .read_n
		.readdata      (mm_interconnect_0_epcs_epcs_control_port_readdata),   //                  .readdata
		.readyfordata  (),                                                    //                  .readyfordata
		.write_n       (~mm_interconnect_0_epcs_epcs_control_port_write),     //                  .write_n
		.writedata     (mm_interconnect_0_epcs_epcs_control_port_writedata),  //                  .writedata
		.irq           (irq_mapper_receiver1_irq),                            //               irq.irq
		.dclk          (epcs_dclk),                                           //          external.export
		.sce           (epcs_sce),                                            //                  .export
		.sdo           (epcs_sdo),                                            //                  .export
		.data0         (epcs_data0)                                           //                  .export
	);

	vl53l1x_pio_sclk pio_sclk (
		.clk        (clk_clk),                                  //                 clk.clk
		.reset_n    (~rst_controller_reset_out_reset),          //               reset.reset_n
		.address    (mm_interconnect_0_pio_sclk_s1_address),    //                  s1.address
		.write_n    (~mm_interconnect_0_pio_sclk_s1_write),     //                    .write_n
		.writedata  (mm_interconnect_0_pio_sclk_s1_writedata),  //                    .writedata
		.chipselect (mm_interconnect_0_pio_sclk_s1_chipselect), //                    .chipselect
		.readdata   (mm_interconnect_0_pio_sclk_s1_readdata),   //                    .readdata
		.out_port   (i2c_sclk_export)                           // external_connection.export
	);

	vl53l1x_pio_sda pio_sda (
		.clk        (clk_clk),                                 //                 clk.clk
		.reset_n    (~rst_controller_reset_out_reset),         //               reset.reset_n
		.address    (mm_interconnect_0_pio_sda_s1_address),    //                  s1.address
		.write_n    (~mm_interconnect_0_pio_sda_s1_write),     //                    .write_n
		.writedata  (mm_interconnect_0_pio_sda_s1_writedata),  //                    .writedata
		.chipselect (mm_interconnect_0_pio_sda_s1_chipselect), //                    .chipselect
		.readdata   (mm_interconnect_0_pio_sda_s1_readdata),   //                    .readdata
		.bidir_port (i2c_sda_export)                           // external_connection.export
	);

	vl53l1x_pio_ge pio_ge (
		.clk        (clk_clk),                                //                 clk.clk
		.reset_n    (~rst_controller_reset_out_reset),        //               reset.reset_n
		.address    (mm_interconnect_0_pio_ge_s1_address),    //                  s1.address
		.write_n    (~mm_interconnect_0_pio_ge_s1_write),     //                    .write_n
		.writedata  (mm_interconnect_0_pio_ge_s1_writedata),  //                    .writedata
		.chipselect (mm_interconnect_0_pio_ge_s1_chipselect), //                    .chipselect
		.readdata   (mm_interconnect_0_pio_ge_s1_readdata),   //                    .readdata
		.out_port   (ge_export)                               // external_connection.export
	);

	vl53l1x_pio_ge pio_shi (
		.clk        (clk_clk),                                 //                 clk.clk
		.reset_n    (~rst_controller_reset_out_reset),         //               reset.reset_n
		.address    (mm_interconnect_0_pio_shi_s1_address),    //                  s1.address
		.write_n    (~mm_interconnect_0_pio_shi_s1_write),     //                    .write_n
		.writedata  (mm_interconnect_0_pio_shi_s1_writedata),  //                    .writedata
		.chipselect (mm_interconnect_0_pio_shi_s1_chipselect), //                    .chipselect
		.readdata   (mm_interconnect_0_pio_shi_s1_readdata),   //                    .readdata
		.out_port   (shi_export)                               // external_connection.export
	);

	vl53l1x_pio_ge pio_bai (
		.clk        (clk_clk),                                 //                 clk.clk
		.reset_n    (~rst_controller_reset_out_reset),         //               reset.reset_n
		.address    (mm_interconnect_0_pio_bai_s1_address),    //                  s1.address
		.write_n    (~mm_interconnect_0_pio_bai_s1_write),     //                    .write_n
		.writedata  (mm_interconnect_0_pio_bai_s1_writedata),  //                    .writedata
		.chipselect (mm_interconnect_0_pio_bai_s1_chipselect), //                    .chipselect
		.readdata   (mm_interconnect_0_pio_bai_s1_readdata),   //                    .readdata
		.out_port   (bai_export)                               // external_connection.export
	);

	vl53l1x_pio_ge pio_qian (
		.clk        (clk_clk),                                  //                 clk.clk
		.reset_n    (~rst_controller_reset_out_reset),          //               reset.reset_n
		.address    (mm_interconnect_0_pio_qian_s1_address),    //                  s1.address
		.write_n    (~mm_interconnect_0_pio_qian_s1_write),     //                    .write_n
		.writedata  (mm_interconnect_0_pio_qian_s1_writedata),  //                    .writedata
		.chipselect (mm_interconnect_0_pio_qian_s1_chipselect), //                    .chipselect
		.readdata   (mm_interconnect_0_pio_qian_s1_readdata),   //                    .readdata
		.out_port   (qian_export)                               // external_connection.export
	);

	vl53l1x_mm_interconnect_0 mm_interconnect_0 (
		.clk_0_clk_clk                                    (clk_clk),                                                      //                                  clk_0_clk.clk
		.jtag_uart_reset_reset_bridge_in_reset_reset      (rst_controller_001_reset_out_reset),                           //      jtag_uart_reset_reset_bridge_in_reset.reset
		.nios2_qsys_0_reset_n_reset_bridge_in_reset_reset (rst_controller_reset_out_reset),                               // nios2_qsys_0_reset_n_reset_bridge_in_reset.reset
		.nios2_qsys_0_data_master_address                 (nios2_qsys_0_data_master_address),                             //                   nios2_qsys_0_data_master.address
		.nios2_qsys_0_data_master_waitrequest             (nios2_qsys_0_data_master_waitrequest),                         //                                           .waitrequest
		.nios2_qsys_0_data_master_byteenable              (nios2_qsys_0_data_master_byteenable),                          //                                           .byteenable
		.nios2_qsys_0_data_master_read                    (nios2_qsys_0_data_master_read),                                //                                           .read
		.nios2_qsys_0_data_master_readdata                (nios2_qsys_0_data_master_readdata),                            //                                           .readdata
		.nios2_qsys_0_data_master_write                   (nios2_qsys_0_data_master_write),                               //                                           .write
		.nios2_qsys_0_data_master_writedata               (nios2_qsys_0_data_master_writedata),                           //                                           .writedata
		.nios2_qsys_0_data_master_debugaccess             (nios2_qsys_0_data_master_debugaccess),                         //                                           .debugaccess
		.nios2_qsys_0_instruction_master_address          (nios2_qsys_0_instruction_master_address),                      //            nios2_qsys_0_instruction_master.address
		.nios2_qsys_0_instruction_master_waitrequest      (nios2_qsys_0_instruction_master_waitrequest),                  //                                           .waitrequest
		.nios2_qsys_0_instruction_master_read             (nios2_qsys_0_instruction_master_read),                         //                                           .read
		.nios2_qsys_0_instruction_master_readdata         (nios2_qsys_0_instruction_master_readdata),                     //                                           .readdata
		.nios2_qsys_0_instruction_master_readdatavalid    (nios2_qsys_0_instruction_master_readdatavalid),                //                                           .readdatavalid
		.epcs_epcs_control_port_address                   (mm_interconnect_0_epcs_epcs_control_port_address),             //                     epcs_epcs_control_port.address
		.epcs_epcs_control_port_write                     (mm_interconnect_0_epcs_epcs_control_port_write),               //                                           .write
		.epcs_epcs_control_port_read                      (mm_interconnect_0_epcs_epcs_control_port_read),                //                                           .read
		.epcs_epcs_control_port_readdata                  (mm_interconnect_0_epcs_epcs_control_port_readdata),            //                                           .readdata
		.epcs_epcs_control_port_writedata                 (mm_interconnect_0_epcs_epcs_control_port_writedata),           //                                           .writedata
		.epcs_epcs_control_port_chipselect                (mm_interconnect_0_epcs_epcs_control_port_chipselect),          //                                           .chipselect
		.jtag_uart_avalon_jtag_slave_address              (mm_interconnect_0_jtag_uart_avalon_jtag_slave_address),        //                jtag_uart_avalon_jtag_slave.address
		.jtag_uart_avalon_jtag_slave_write                (mm_interconnect_0_jtag_uart_avalon_jtag_slave_write),          //                                           .write
		.jtag_uart_avalon_jtag_slave_read                 (mm_interconnect_0_jtag_uart_avalon_jtag_slave_read),           //                                           .read
		.jtag_uart_avalon_jtag_slave_readdata             (mm_interconnect_0_jtag_uart_avalon_jtag_slave_readdata),       //                                           .readdata
		.jtag_uart_avalon_jtag_slave_writedata            (mm_interconnect_0_jtag_uart_avalon_jtag_slave_writedata),      //                                           .writedata
		.jtag_uart_avalon_jtag_slave_waitrequest          (mm_interconnect_0_jtag_uart_avalon_jtag_slave_waitrequest),    //                                           .waitrequest
		.jtag_uart_avalon_jtag_slave_chipselect           (mm_interconnect_0_jtag_uart_avalon_jtag_slave_chipselect),     //                                           .chipselect
		.nios2_qsys_0_jtag_debug_module_address           (mm_interconnect_0_nios2_qsys_0_jtag_debug_module_address),     //             nios2_qsys_0_jtag_debug_module.address
		.nios2_qsys_0_jtag_debug_module_write             (mm_interconnect_0_nios2_qsys_0_jtag_debug_module_write),       //                                           .write
		.nios2_qsys_0_jtag_debug_module_read              (mm_interconnect_0_nios2_qsys_0_jtag_debug_module_read),        //                                           .read
		.nios2_qsys_0_jtag_debug_module_readdata          (mm_interconnect_0_nios2_qsys_0_jtag_debug_module_readdata),    //                                           .readdata
		.nios2_qsys_0_jtag_debug_module_writedata         (mm_interconnect_0_nios2_qsys_0_jtag_debug_module_writedata),   //                                           .writedata
		.nios2_qsys_0_jtag_debug_module_byteenable        (mm_interconnect_0_nios2_qsys_0_jtag_debug_module_byteenable),  //                                           .byteenable
		.nios2_qsys_0_jtag_debug_module_waitrequest       (mm_interconnect_0_nios2_qsys_0_jtag_debug_module_waitrequest), //                                           .waitrequest
		.nios2_qsys_0_jtag_debug_module_debugaccess       (mm_interconnect_0_nios2_qsys_0_jtag_debug_module_debugaccess), //                                           .debugaccess
		.pio_bai_s1_address                               (mm_interconnect_0_pio_bai_s1_address),                         //                                 pio_bai_s1.address
		.pio_bai_s1_write                                 (mm_interconnect_0_pio_bai_s1_write),                           //                                           .write
		.pio_bai_s1_readdata                              (mm_interconnect_0_pio_bai_s1_readdata),                        //                                           .readdata
		.pio_bai_s1_writedata                             (mm_interconnect_0_pio_bai_s1_writedata),                       //                                           .writedata
		.pio_bai_s1_chipselect                            (mm_interconnect_0_pio_bai_s1_chipselect),                      //                                           .chipselect
		.pio_ge_s1_address                                (mm_interconnect_0_pio_ge_s1_address),                          //                                  pio_ge_s1.address
		.pio_ge_s1_write                                  (mm_interconnect_0_pio_ge_s1_write),                            //                                           .write
		.pio_ge_s1_readdata                               (mm_interconnect_0_pio_ge_s1_readdata),                         //                                           .readdata
		.pio_ge_s1_writedata                              (mm_interconnect_0_pio_ge_s1_writedata),                        //                                           .writedata
		.pio_ge_s1_chipselect                             (mm_interconnect_0_pio_ge_s1_chipselect),                       //                                           .chipselect
		.pio_qian_s1_address                              (mm_interconnect_0_pio_qian_s1_address),                        //                                pio_qian_s1.address
		.pio_qian_s1_write                                (mm_interconnect_0_pio_qian_s1_write),                          //                                           .write
		.pio_qian_s1_readdata                             (mm_interconnect_0_pio_qian_s1_readdata),                       //                                           .readdata
		.pio_qian_s1_writedata                            (mm_interconnect_0_pio_qian_s1_writedata),                      //                                           .writedata
		.pio_qian_s1_chipselect                           (mm_interconnect_0_pio_qian_s1_chipselect),                     //                                           .chipselect
		.pio_sclk_s1_address                              (mm_interconnect_0_pio_sclk_s1_address),                        //                                pio_sclk_s1.address
		.pio_sclk_s1_write                                (mm_interconnect_0_pio_sclk_s1_write),                          //                                           .write
		.pio_sclk_s1_readdata                             (mm_interconnect_0_pio_sclk_s1_readdata),                       //                                           .readdata
		.pio_sclk_s1_writedata                            (mm_interconnect_0_pio_sclk_s1_writedata),                      //                                           .writedata
		.pio_sclk_s1_chipselect                           (mm_interconnect_0_pio_sclk_s1_chipselect),                     //                                           .chipselect
		.pio_sda_s1_address                               (mm_interconnect_0_pio_sda_s1_address),                         //                                 pio_sda_s1.address
		.pio_sda_s1_write                                 (mm_interconnect_0_pio_sda_s1_write),                           //                                           .write
		.pio_sda_s1_readdata                              (mm_interconnect_0_pio_sda_s1_readdata),                        //                                           .readdata
		.pio_sda_s1_writedata                             (mm_interconnect_0_pio_sda_s1_writedata),                       //                                           .writedata
		.pio_sda_s1_chipselect                            (mm_interconnect_0_pio_sda_s1_chipselect),                      //                                           .chipselect
		.pio_shi_s1_address                               (mm_interconnect_0_pio_shi_s1_address),                         //                                 pio_shi_s1.address
		.pio_shi_s1_write                                 (mm_interconnect_0_pio_shi_s1_write),                           //                                           .write
		.pio_shi_s1_readdata                              (mm_interconnect_0_pio_shi_s1_readdata),                        //                                           .readdata
		.pio_shi_s1_writedata                             (mm_interconnect_0_pio_shi_s1_writedata),                       //                                           .writedata
		.pio_shi_s1_chipselect                            (mm_interconnect_0_pio_shi_s1_chipselect),                      //                                           .chipselect
		.ram_s1_address                                   (mm_interconnect_0_ram_s1_address),                             //                                     ram_s1.address
		.ram_s1_write                                     (mm_interconnect_0_ram_s1_write),                               //                                           .write
		.ram_s1_readdata                                  (mm_interconnect_0_ram_s1_readdata),                            //                                           .readdata
		.ram_s1_writedata                                 (mm_interconnect_0_ram_s1_writedata),                           //                                           .writedata
		.ram_s1_byteenable                                (mm_interconnect_0_ram_s1_byteenable),                          //                                           .byteenable
		.ram_s1_chipselect                                (mm_interconnect_0_ram_s1_chipselect),                          //                                           .chipselect
		.ram_s1_clken                                     (mm_interconnect_0_ram_s1_clken),                               //                                           .clken
		.sysid_control_slave_address                      (mm_interconnect_0_sysid_control_slave_address),                //                        sysid_control_slave.address
		.sysid_control_slave_readdata                     (mm_interconnect_0_sysid_control_slave_readdata)                //                                           .readdata
	);

	vl53l1x_irq_mapper irq_mapper (
		.clk           (clk_clk),                        //       clk.clk
		.reset         (rst_controller_reset_out_reset), // clk_reset.reset
		.receiver0_irq (irq_mapper_receiver0_irq),       // receiver0.irq
		.receiver1_irq (irq_mapper_receiver1_irq),       // receiver1.irq
		.sender_irq    (nios2_qsys_0_d_irq_irq)          //    sender.irq
	);

	altera_reset_controller #(
		.NUM_RESET_INPUTS          (1),
		.OUTPUT_RESET_SYNC_EDGES   ("deassert"),
		.SYNC_DEPTH                (2),
		.RESET_REQUEST_PRESENT     (1),
		.RESET_REQ_WAIT_TIME       (1),
		.MIN_RST_ASSERTION_TIME    (3),
		.RESET_REQ_EARLY_DSRT_TIME (1),
		.USE_RESET_REQUEST_IN0     (0),
		.USE_RESET_REQUEST_IN1     (0),
		.USE_RESET_REQUEST_IN2     (0),
		.USE_RESET_REQUEST_IN3     (0),
		.USE_RESET_REQUEST_IN4     (0),
		.USE_RESET_REQUEST_IN5     (0),
		.USE_RESET_REQUEST_IN6     (0),
		.USE_RESET_REQUEST_IN7     (0),
		.USE_RESET_REQUEST_IN8     (0),
		.USE_RESET_REQUEST_IN9     (0),
		.USE_RESET_REQUEST_IN10    (0),
		.USE_RESET_REQUEST_IN11    (0),
		.USE_RESET_REQUEST_IN12    (0),
		.USE_RESET_REQUEST_IN13    (0),
		.USE_RESET_REQUEST_IN14    (0),
		.USE_RESET_REQUEST_IN15    (0),
		.ADAPT_RESET_REQUEST       (0)
	) rst_controller (
		.reset_in0      (~reset_reset_n),                     // reset_in0.reset
		.clk            (clk_clk),                            //       clk.clk
		.reset_out      (rst_controller_reset_out_reset),     // reset_out.reset
		.reset_req      (rst_controller_reset_out_reset_req), //          .reset_req
		.reset_req_in0  (1'b0),                               // (terminated)
		.reset_in1      (1'b0),                               // (terminated)
		.reset_req_in1  (1'b0),                               // (terminated)
		.reset_in2      (1'b0),                               // (terminated)
		.reset_req_in2  (1'b0),                               // (terminated)
		.reset_in3      (1'b0),                               // (terminated)
		.reset_req_in3  (1'b0),                               // (terminated)
		.reset_in4      (1'b0),                               // (terminated)
		.reset_req_in4  (1'b0),                               // (terminated)
		.reset_in5      (1'b0),                               // (terminated)
		.reset_req_in5  (1'b0),                               // (terminated)
		.reset_in6      (1'b0),                               // (terminated)
		.reset_req_in6  (1'b0),                               // (terminated)
		.reset_in7      (1'b0),                               // (terminated)
		.reset_req_in7  (1'b0),                               // (terminated)
		.reset_in8      (1'b0),                               // (terminated)
		.reset_req_in8  (1'b0),                               // (terminated)
		.reset_in9      (1'b0),                               // (terminated)
		.reset_req_in9  (1'b0),                               // (terminated)
		.reset_in10     (1'b0),                               // (terminated)
		.reset_req_in10 (1'b0),                               // (terminated)
		.reset_in11     (1'b0),                               // (terminated)
		.reset_req_in11 (1'b0),                               // (terminated)
		.reset_in12     (1'b0),                               // (terminated)
		.reset_req_in12 (1'b0),                               // (terminated)
		.reset_in13     (1'b0),                               // (terminated)
		.reset_req_in13 (1'b0),                               // (terminated)
		.reset_in14     (1'b0),                               // (terminated)
		.reset_req_in14 (1'b0),                               // (terminated)
		.reset_in15     (1'b0),                               // (terminated)
		.reset_req_in15 (1'b0)                                // (terminated)
	);

	altera_reset_controller #(
		.NUM_RESET_INPUTS          (2),
		.OUTPUT_RESET_SYNC_EDGES   ("deassert"),
		.SYNC_DEPTH                (2),
		.RESET_REQUEST_PRESENT     (0),
		.RESET_REQ_WAIT_TIME       (1),
		.MIN_RST_ASSERTION_TIME    (3),
		.RESET_REQ_EARLY_DSRT_TIME (1),
		.USE_RESET_REQUEST_IN0     (0),
		.USE_RESET_REQUEST_IN1     (0),
		.USE_RESET_REQUEST_IN2     (0),
		.USE_RESET_REQUEST_IN3     (0),
		.USE_RESET_REQUEST_IN4     (0),
		.USE_RESET_REQUEST_IN5     (0),
		.USE_RESET_REQUEST_IN6     (0),
		.USE_RESET_REQUEST_IN7     (0),
		.USE_RESET_REQUEST_IN8     (0),
		.USE_RESET_REQUEST_IN9     (0),
		.USE_RESET_REQUEST_IN10    (0),
		.USE_RESET_REQUEST_IN11    (0),
		.USE_RESET_REQUEST_IN12    (0),
		.USE_RESET_REQUEST_IN13    (0),
		.USE_RESET_REQUEST_IN14    (0),
		.USE_RESET_REQUEST_IN15    (0),
		.ADAPT_RESET_REQUEST       (0)
	) rst_controller_001 (
		.reset_in0      (~reset_reset_n),                             // reset_in0.reset
		.reset_in1      (nios2_qsys_0_jtag_debug_module_reset_reset), // reset_in1.reset
		.clk            (clk_clk),                                    //       clk.clk
		.reset_out      (rst_controller_001_reset_out_reset),         // reset_out.reset
		.reset_req      (),                                           // (terminated)
		.reset_req_in0  (1'b0),                                       // (terminated)
		.reset_req_in1  (1'b0),                                       // (terminated)
		.reset_in2      (1'b0),                                       // (terminated)
		.reset_req_in2  (1'b0),                                       // (terminated)
		.reset_in3      (1'b0),                                       // (terminated)
		.reset_req_in3  (1'b0),                                       // (terminated)
		.reset_in4      (1'b0),                                       // (terminated)
		.reset_req_in4  (1'b0),                                       // (terminated)
		.reset_in5      (1'b0),                                       // (terminated)
		.reset_req_in5  (1'b0),                                       // (terminated)
		.reset_in6      (1'b0),                                       // (terminated)
		.reset_req_in6  (1'b0),                                       // (terminated)
		.reset_in7      (1'b0),                                       // (terminated)
		.reset_req_in7  (1'b0),                                       // (terminated)
		.reset_in8      (1'b0),                                       // (terminated)
		.reset_req_in8  (1'b0),                                       // (terminated)
		.reset_in9      (1'b0),                                       // (terminated)
		.reset_req_in9  (1'b0),                                       // (terminated)
		.reset_in10     (1'b0),                                       // (terminated)
		.reset_req_in10 (1'b0),                                       // (terminated)
		.reset_in11     (1'b0),                                       // (terminated)
		.reset_req_in11 (1'b0),                                       // (terminated)
		.reset_in12     (1'b0),                                       // (terminated)
		.reset_req_in12 (1'b0),                                       // (terminated)
		.reset_in13     (1'b0),                                       // (terminated)
		.reset_req_in13 (1'b0),                                       // (terminated)
		.reset_in14     (1'b0),                                       // (terminated)
		.reset_req_in14 (1'b0),                                       // (terminated)
		.reset_in15     (1'b0),                                       // (terminated)
		.reset_req_in15 (1'b0)                                        // (terminated)
	);

endmodule
